
import java.sql.*; 
import java.io.*; 

class sqlplus { 
  public static void main (String args []) 
      throws SQLException, IOException { 

    try {
      Class.forName ("oracle.jdbc.driver.OracleDriver");
    } catch (ClassNotFoundException e) {
        System.out.println ("Could not load the driver"); 
      }

    String user, pass;
    user = readEntry("userid  : ");
    pass = readEntry("password: ");
    Connection conn =  DriverManager.getConnection
                            ("jdbc:oracle:oci8:@addb", user, pass);

    System.out.println("Welcome to the SQL Interpreter\n");
    System.out.print("SQL> ");
    Statement stmt = conn.createStatement (); 
    do {
      String query = readQuery();

      if (query .equals("exit")) 
        break;
      ResultSet rset = null;
      boolean isQuery;
      try {
        if (isQuery = stmt.execute(query)) 
            rset = stmt.getResultSet();
      } catch (SQLException e) {
          System.out.print("Not well formed query: ");
          System.out.println(e.getMessage());
  /*        while ((e = e.getNextException()) != null) {
              e.printStackTrace();
          }
  */
          continue;
      }
      
      if (! isQuery) {
           System.out.println(query + " : executed.");
           continue;
      }

      ResultSetMetaData rsetmd = rset.getMetaData();
      int nCols = rsetmd.getColumnCount();
      int totalCols = nCols;

      for (int i = 1; i <= nCols; i++) {
        System.out.print(rsetmd.getColumnName(i));
        int colSize = rsetmd.getColumnDisplaySize(i);
        totalCols += colSize;

        for (int k=0; k < colSize-rsetmd.getColumnName(i).length(); k++)
          System.out.print(" ");
        System.out.print(" ");
      }
      System.out.println("");

      for (int i=0; i<totalCols; i++) 
          System.out.print("-");
      System.out.println("");

      while (rset.next ()) { 
        for (int i = 1; i <= nCols; i++) {
          String val = rset.getString(i);
          int colSize = rsetmd.getColumnDisplaySize(i);
          int printedSize = 0;

          if (rset.wasNull()) {
             System.out.print("null");
             printedSize = 4;
          }
          else {
              System.out.print(rset.getString(i));
              printedSize = rset.getString(i).length();
          }
          for (int k=0; k <= colSize-printedSize; k++)
              System.out.print(" ");
          
        }
        System.out.println("");
      } 
    } while (true);  
    stmt.close();
    conn.close();
    System.out.println("Thank you for using the SQL Interpreter\n");
  } 

  //readEntry function -- to read input string
  static String readQuery() {
     try {
       StringBuffer buffer = new StringBuffer();
       System.out.flush();
       int c = System.in.read();
       while(c != ';' && c != -1) {
         if (c != '\n') 
           buffer.append((char)c);
         else {
           buffer.append(" ");
           System.out.print("SQL> ");
           System.out.flush();
         }
         c = System.in.read();
       }
       return buffer.toString().trim();
     } catch (IOException e) {
       return "";
       }
   }

  //readEntry function -- to read input string
  static String readEntry(String prompt) {
     try {
       StringBuffer buffer = new StringBuffer();
       System.out.print(prompt);
       System.out.flush();
       int c = System.in.read();
       while(c != '\n' && c != -1) {
         buffer.append((char)c);
         c = System.in.read();
       }
       return buffer.toString().trim();
     } catch (IOException e) {
       return "";
       }
   }

} 
